#include "8052def.c"
#include "defs.h"
#include "scopeclk.h"

#define INT0 1                  /*anzeige von ext.int0 initiiert*/
                                /*.. 50Hz-Trigger*/
extern MENU anzeige;
extern BYTE taste, tmp_taste;
extern BYTE DLINE_F_XDIR, DLINE_F_YDIR, DLINE_F_SWXY, DLINE_F_ENEG;


BYTE get_taste(void)
{
#asm
taste1          equ     00000100b
taste2          equ     00010000b
taste3          equ     01000000b
keine_taste     equ     0ffh
taste_gefunden  equ     1

                push    ACC
                push    AR6
                push    AR5
                mov     a, #keine_taste
                cjne    a, .tmp_taste, ta_z00
                ajmp    ta_z0
ta_z00:         mov     a, #taste_gefunden
                cjne    a, .tmp_taste, ta_z1
                ajmp    ta_z2

                ;keine taste gefunden->tastatur erstes mal einlesen
ta_z0:          mov     a, P1
                anl     a, #(taste1+taste2+taste3)
                xrl     a, #(taste1+taste2+taste3)
                jz      ta_nichts       ;keine taste bettigt->fertig
                mov     .tmp_taste, a   ;..sonst vorlufig speichern
                mov     r0, #keine_taste
                ajmp    ta_ende

                ;zwischenspeicher mit tastatur vergleichen
ta_z1:
                mov     r5, #10h        ;verzgerung wg taster-prellen
taw:            mov     r6, #0ffh
                djnz    r6, $
                djnz    r5, taw
                mov     a, P1           ;tastatur nocheinmal einlesen
                anl     a, #(taste1+taste2+taste3)
                xrl     a, #(taste1+taste2+taste3)
                cjne    a, .tmp_taste, ta_nichts;fehlalarm->fertig
                mov     .tmp_taste, #taste_gefunden

neue_taste1:    cjne    a, #taste1, neue_taste2
                mov     r0, #0
                ajmp    ta_ende
neue_taste2:    cjne    a, #taste2, neue_taste3
                mov     r0, #1
                ajmp    ta_ende
neue_taste3:    cjne    a, #(taste1+taste2), neue_taste4
                mov     r0, #2
                ajmp    ta_ende
neue_taste4:    mov     r0, #3
                ajmp    ta_ende

                ;auf loslassen der taste warten
ta_z2:          mov     a, P1
                anl     a, #(taste1+taste2+taste3)
                xrl     a, #(taste1+taste2+taste3)
                jnz     ta_z2

ta_nichts:      mov     r0, #keine_taste
                mov     .tmp_taste, #keine_taste
ta_ende:
                pop     AR5
                pop     AR6
                pop     ACC
#endasm
}

#ifdef TIMER0

_intrpt _TIMER0 tfun()
{

#asm

DL_R3 equ 3h

cseg segment
        extrn anzeige

                clr     EA
                setb    P3.4            ;blank
                clr     TR0             ;timer0 unbedingt anhalten
                mov     TL1, #0
                mov     TH1, #0
                setb    TR1             ;timer1 starten

                mov     R0, #0
                mov r1, #128
                mov r2, #128
                mov r3, #128
                mov r4, #128

                mov     a, .anzeige+1
                mov     DPL, a
                mov     a, .anzeige+2
                mov     DPH, a
                mov     r0, #0
                clr     a
                movc    a, @a+dptr
                mov     r1, a
                inc     dptr
                clr     a
                movc    a, @a+dptr
                mov     r2, a
                inc     dptr

main_loop:      clr     a
                movc    a, @a+dptr
                inc     dptr
                jz      lop1
                cjne    a, #0ffh, lop2

                mov     a, #.anzeige+3
                add     a, r0
                add     a, r0
                mov     r1, a
                mov     a, @r1
                mov     DPL, a
                inc     r1
                mov     a, @r1
                mov     DPH, a
                inc     r0
                mov     a, r0
                cjne    a, .anzeige, lop1

                ajmp    t0inte_end

lop1:           ;setb    P1.1            ;blank
                setb    P3.4

                clr     a
                movc    a, @a+dptr
                inc     dptr
                mov     r1, a
                clr     a
                movc    a, @a+dptr
                inc     dptr
                mov     r2, a
                ajmp    main_loop

lop2:           mov     r3, a
                clr     a
                movc    a, @a+dptr
                inc     dptr
                mov     r4, a
lop3:
;               -----------------------------------------------------------------------------
;               ---   Linie Zeichnen
;               -----------------------------------------------------------------------------

                lcall DrawLine
                AJMP  main_loop

t0inte_end:
                ;setb    P1.1                  ;blank
                setb    P3.4

                mov     a, #0
                mov     dptr, #80d0h
                movx    @dptr, a
                mov     dptr, #80c0h
                movx    @dptr, a


                clr     TR1
                mov     a, TL1
                mov     TL0, a
                mov     a, TH1
                clr     c
                subb    a, #80h
                mov     TH0, a

                mov     TH0, #0
                mov     TL0, #0

                SETB  TCON.4                   ; und weier
                setb    EA
#endasm
}
#else

_intrpt _EXTI0 ext0fun()
{
#asm
DL_R3 equ 3h
        extrn anzeige
cseg segment
                setb    P3.0                    ;indikatur fr laufzeitmessung setzen
                mov     R0, #0
                mov     r1, #128
                mov     r2, #128
                mov     r3, #128
                mov     r4, #128

                mov     a, .anzeige+1           ;datenzeiger beginnen an..
                mov     DPL, a                  ;..position1 der anzeigestruktur
                mov     a, .anzeige+2
                mov     DPH, a                  ;datapointer mit 1.zeiger in die..
                mov     r0, #0                  ;..anzeigedaten laden.
                clr     a                       ;r0 indiziert anzeigedaten

                movc    a, @a+dptr              ;in jedem falle gehts mit den..
                mov     r1, a                   ;..x,y-koordinaten des ersten..
                inc     dptr                    ;..punktes los
                clr     a
                movc    a, @a+dptr
                mov     r2, a
                inc     dptr

main_tloop:     clr     a                       ;auf steueranweisungen fr die...
                movc    a, @a+dptr              ;..strahlfhrung prfen
                inc     dptr
                jz      tlop1                   ;strahl ausschalten?->weiter
                cjne    a, #0ffh, tlop2         ;ende tabelleneintrag erreicht?->fertig

                mov     a, #.anzeige+3
                add     a, r0                   ;anzeigedaten sind ber 16-bit-zeiger..
                add     a, r0                   ;..zugnglich -> r0*2
                mov     r1, a
                mov     a, @r1
                mov     DPL, a                  ;zeiger auf nchsten tabellen-
                inc     r1                      ;eintrag nach dptr
                mov     a, @r1
                mov     DPH, a
                inc     r0
                mov     a, r0
                cjne    a, .anzeige, tlop1      ;alle tabelleneintrge..
                                                ;..abgearbeitet?
                ajmp    ext0inte_end            ;ja->fertig

tlop1:          setb    P3.4                    ;blank

                clr     a                       ;neuen startpunkt liniensegment..
                movc    a, @a+dptr              ;..laden
                inc     dptr
                mov     r1, a
                clr     a
                movc    a, @a+dptr
                inc     dptr
                mov     r2, a
                ajmp    main_tloop

tlop2:          mov     r3, a                   ;endepunkt liniensegment laden
                clr     a
                movc    a, @a+dptr
                inc     dptr
                mov     r4, a
tlop3:
;               -----------------------------------------------------------------------------
;               ---   Linie Zeichnen
;               -----------------------------------------------------------------------------

                lcall DrawLine
                AJMP  main_tloop

ext0inte_end:
                setb    P3.4                    ;blank

                mov     a, #0                   ;elektronenstrahl aus dem..
                mov     dptr, #80d0h            ;..sichtbereich ablenken
                movx    @dptr, a
                mov     dptr, #80c0h
                movx    @dptr, a
                clr P3.0                        ;laufzeitindikator lschen
#endasm
}
#endif

#asm
cseg segment
;               *****************************************************************************
;               ***   Linien-Routine
;               ***
;               ***   Parameter:
;               ***     R1 - X-Start
;               ***     R2 - Y-Start
;               ***     R3 - X-Ziel
;               ***     R4 - Y-Ziel
;               ***
;               ***   Rckgabe:
;               ***     DLINE_FLAGS - Status-Register
;               ***     R5          - DeltaX
;               ***     R6          - DeltaY
;               ***     R7          - Fehler-Register
;               ***
;               ***   Bugs:
;               ***     Fehlerregister hat ein Bit zu wenig, um
;               ***     DeltaY-Werte > 127 zu verarbeiten
;               ***     Reicht aber fr unsere Zwecke
;               *****************************************************************************

DrawLine:
                mov     .DLINE_F_XDIR, #0
                mov     .DLINE_F_YDIR, #0
                mov     .DLINE_F_SWXY, #0
                mov     .DLINE_F_ENEG, #0
                ;MOV   DLINE_FLAGS,#0           ; Status initialisieren
;               -----------------------------------------------------------------------------
;               ---   DAC initialisieren, wenn Strahl aus ist
;               -----------------------------------------------------------------------------

                ;jnb P1.1,DrawLine_DLT
                jnb P3.4,DrawLine_DLT

                inc     86h                     ;auf zweiten dptr umschalten
                mov     a, r2
                mov     dptr, #80d0h
                movx    @dptr, a
                mov     a, r1
                mov     dptr, #80c0h
                movx    @dptr, a
                inc     86h                     ;alten dptr aktivieren

;               -----------------------------------------------------------------------------
;               ---   Deltas berechnen
;               -----------------------------------------------------------------------------
DrawLine_DLT:
                CLR   C                        ; deltaX berechnen
                MOV   A,R1
                SUBB  A,R3
                JNC   DrawLine_DXC
                DEC   A
                XRL   A,#0FFh
DrawLine_DXC:
                MOV   R5,A
                CLR   C                        ; deltaY berechnen
                MOV   A,R2
                SUBB  A,R4
                JNC   DrawLine_DYC
                DEC   A
                XRL   A,#0FFh
DrawLine_DYC:
                MOV   R6,A
;               -----------------------------------------------------------------------------
;               ---   X- und Y-Werte tauschen, wenn erforderlich
;               -----------------------------------------------------------------------------
                CLR   C                        ; deltaX mu > deltaY sein
                MOV   A,R5                     ; wenn doch, X- und Y-Werte tauschen
                SUBB  A,R6
                JNC   DrawLine_DIR
                ;SETB  DLINE_F_SWXY
                mov   .DLINE_F_SWXY, #1
                MOV   A,R1
                XCH   A,R2
                MOV   R1,A
                MOV   A,R3
                XCH   A,R4
                MOV   R3,A
                MOV   A,R5
                XCH   A,R6
                MOV   R5,A
;               -----------------------------------------------------------------------------
;               ---   Richtungen ermitteln
;               -----------------------------------------------------------------------------
DrawLine_DIR:
                CLR   C                        ; X-Richtung ermitteln
                MOV   A,R3
                SUBB  A,R1
                ;MOV   DLINE_F_XDIR,C
                MOV     .DLINE_F_XDIR, #1
                jc      dr1
                MOV     .DLINE_F_XDIR, #0
dr1:
                CLR   C                        ; Y-Richtung ermitteln
                MOV   A,R4
                SUBB  A,R2
                ;MOV   DLINE_F_YDIR,C
                MOV     .DLINE_F_YDIR, #1
                jc      dr2
                MOV     .DLINE_F_YDIR, #0
dr2:

;               -----------------------------------------------------------------------------
;               ---   Flags setzen
;               -----------------------------------------------------------------------------
                MOV   R7,#0                    ; Fehler-Register initialisieren
                ;clr    P1.1
                clr     P3.4
;               -----------------------------------------------------------------------------
;               ---   DAC aktualisieren
;               -----------------------------------------------------------------------------
DrawLineLoop:
                ;MOV   C,DLINE_F_SWXY           ; Swaping von X/Y bercksichtigen

                inc     86h
                MOV     a,.DLINE_F_SWXY           ; Swaping von X/Y bercksichtigen
                jnz     swapdac
                ;jc      swapdac
                mov     a, r2
                mov     dptr, #80d0h
                movx    @dptr, a
                nop
                mov     a, r1
                mov     dptr, #80c0h
                movx    @dptr, a
                ajmp     dacend
swapdac:
                mov     a, r1
                mov     dptr, #80d0h
                movx    @dptr, a
                nop
                mov     a, r2
                mov     dptr, #80c0h
                movx    @dptr, a

dacend:
                inc     86h
tl_2:
;               -----------------------------------------------------------------------------
;               ---   prfen, ob Ziel erreicht
;               -----------------------------------------------------------------------------
                MOV   A,R1
                CJNE  A,DL_R3,DrawLine_Err
                ;JNB   DLINE_F_SWXY,DrawLine_Out
                mov     a, .DLINE_F_SWXY
                jz      DrawLine_Out
                MOV   A,R1                     ;ggf. X- und Y-Wert zurcktauschen
                XCH   A,R2
                MOV   R1,A
                AJMP  DrawLine_Out
;               -----------------------------------------------------------------------------
;               ---   Fehler aktualisieren
;               -----------------------------------------------------------------------------
DrawLine_Err:
                MOV   A,R7
                ADD   A,R6
                MOV   R7,A
                JNC   DrawLine_ChkY
                ;CLR   DLINE_F_ENEG
                mov     .DLINE_F_ENEG, #0
;               -----------------------------------------------------------------------------
;               ---   Wenn Fehler zu gro, einen Schritt in Y-Richtung
;               -----------------------------------------------------------------------------
DrawLine_ChkY:
                ;JB    DLINE_F_ENEG,DrawLine_IncX
                mov     a, .DLINE_F_ENEG
                jnz     DrawLine_IncX
                MOV   A,R5
                SETB  C
                SUBB  A,R7
                JC    DrawLine_IncY
                SUBB  A,R7
                JC    DrawLine_IncY
                AJMP  DrawLine_IncX
DrawLine_IncY:
                MOV   A,R7                     ; Fehler und Y-Wert aktualisieren
                CLR   C
                SUBB  A,R5
                MOV   R7,A
                ;MOV   DLINE_F_ENEG,C
                MOV     .DLINE_F_ENEG, #1
                jc      dr3
                MOV     .DLINE_F_ENEG, #0
dr3:
                ;JB    DLINE_F_YDIR,DrawLine_IncYN
                MOV     A,.DLINE_F_YDIR
                jnz     DrawLine_IncYN
                INC   R2
                AJMP  DrawLine_IncX
DrawLine_IncYN:
                DEC   R2
;               -----------------------------------------------------------------------------
;               ---   X-Wert aktualisieren
;               -----------------------------------------------------------------------------
DrawLine_IncX:
                ;JB    DLINE_F_XDIR,DrawLine_IncXN
                mov     a,.DLINE_F_XDIR
                jnz     DrawLine_IncXN
                INC   R1
                AJMP  DrawLineLoop
DrawLine_IncXN:
                DEC   R1
                AJMP  DrawLineLoop
DrawLine_Out:
                RET

#endasm
