#include "8052def.c"
#include "defs.h"
#include "scopeclk.h"

#define BATT_OK 1
#define BATT_NOK 0

/**************************************
 * Is Y a Gregorian leap year?
 */
#define leapyear(Y)     ( !(Y %4) && (Y %100) || !(Y %400) )

extern BYTE _code eNumSekOnes[][2];
extern BYTE _code eNumSekTens[][2];
extern BYTE _code eNumMinOnes[][2];
extern BYTE _code eNumMinTens[][2];
extern BYTE _code eNumStdOnes[][2];
extern BYTE _code eNumStdTens[][2];

TAG zeit;
MENU anzeige;

BYTE taste, tmp_taste;

BYTE DLINE_F_XDIR;
BYTE DLINE_F_YDIR;
BYTE DLINE_F_SWXY;
BYTE DLINE_F_ENEG;
BYTE (*hfunptr)(void **);

#include "scopedat.inc"

void main(void)
{       BYTE (*menufun)(void);
        HPTM *m;

#asm
;beim dallas-prozessor die zugriffszeit fr den ram und memio auf
;den hchstmglichen wert setzen
ckcon   equ     7dh
        orl     ckcon, #00000111b
#endasm

        P3.4=0;                         /*rhre dunkel tasten*/

        taste=KEINE_TASTE;
        tmp_taste=KEINE_TASTE;

        P3.2=1;                         /*port-pin vorbereiten*/
        IT0=0;                          /*ext0 pegelgetriggert*/
        EX0=1;                          /*ext0 freigeben*/
        EA= 1;                          /*alle inte freigeben*/

        if(!test_batt())                /*zustand des uhr-akkus prfen*/
        {       init_clock();
                menufun=startmenu.menufun[taste];}
        else                            
        {       init_clock();
                menufun=startmenu.menufun[0];}

        m=(HPTM*)startmenu;
        show_alg_clk();                 /*(analog-)uhr-strukturen init*/

        while(1)                        /*die uhr luft*/
        {
                (*menufun)();
                if((taste=(BYTE)get_taste())!=KEINE_TASTE)
                {       if(taste==2)
                                (*startmenu.menufun[taste])(&m);
                        else
                                menufun=startmenu.menufun[taste];}}

}


BYTE dumfun(void)
{
        return(FALSE);
}

BYTE next_menu(HPTM **m)
{
        *m=(*m)->next;
        return(FALSE);}

BYTE prev_menu(HPTM **m)
{
        *m=(*m)->prev;
        return(FALSE);}

BYTE menuende(void *x)
{       return(TRUE);}

BYTE show_menu(HPTM **m)
{       HPTM *mm;
        BYTE me;

        EA=0;
        P1|=0xfc;                       /*alle tastatur-led ausschalten*/
        EA=1;
        me=FALSE;
        mm=(*m)->daten[2];
        hfunptr=((*m)->daten[3]);
        while(!me)
        {       anzeige.analog_uhr.sek_zgr=mm->cursor;
                anzeige.analog_uhr.skala=(*m)->daten[0];
                anzeige.analog_uhr.tablaenge=*((*m)->daten[1]);
                me=(*hfunptr)(mm);
                if((taste=(BYTE)get_taste())!=KEINE_TASTE)
                        me=(*mm->menufun[taste])(&mm);}
        return(FALSE);
}

BYTE show_time(void)
{
        get_rtc_zeit();
        anzeige.edz.edit_einer_sek=*(BYTE _code**)eNumSekOnes[zeit.uhrzeit.einer_sekunde];
        anzeige.edz.edit_zehner_sek=*(BYTE _code**)eNumSekTens[zeit.uhrzeit.zehner_sekunde];
        anzeige.edz.edit_einer_min=*(BYTE _code**)eNumMinOnes[zeit.uhrzeit.einer_minute];
        anzeige.edz.edit_zehner_min=*(BYTE _code**)eNumMinTens[zeit.uhrzeit.zehner_minute];
        anzeige.edz.edit_einer_std=*(BYTE _code**)eNumStdOnes[zeit.uhrzeit.einer_stunde];
        anzeige.edz.edit_zehner_std=*(BYTE _code**)eNumStdTens[zeit.uhrzeit.zehner_stunde];
        return(FALSE);
}

BYTE show_date(void)
{
        get_rtc_datum();
        anzeige.edd.edit_einer_jahr=*(BYTE _code**)eNumSekOnes[zeit.datum.einer_jahr];
        anzeige.edd.edit_zehner_jahr=*(BYTE _code**)eNumSekTens[zeit.datum.zehner_jahr];
        anzeige.edd.edit_einer_mon=*(BYTE _code**)eNumMinOnes[zeit.datum.einer_monat];
        anzeige.edd.edit_zehner_mon=*(BYTE _code**)eNumMinTens[zeit.datum.zehner_monat];
        anzeige.edd.edit_einer_tag=*(BYTE _code**)eNumStdOnes[zeit.datum.einer_tag];
        anzeige.edd.edit_zehner_tag=*(BYTE _code**)eNumStdTens[zeit.datum.zehner_tag];
        return(FALSE);
}


BYTE edz(void)
{       ZMTO *m;
        ZTM *mm;

        hfunptr=&set_clk;
        m=(ZMTO*)&zmc0;
        mm=m->daten+zeit.zliste[m->zidx];

        show_time();
        anzeige.edz.skala=(BYTE _code*)&zeitmenue3;

        while(1)
        {       anzeige.edz.cursor=m->bc;
                *(BYTE _data**)(m->speicher)=*(BYTE _code**)(mm->zeichen);
                if((taste=(BYTE)get_taste())!=KEINE_TASTE)
                {
                        switch(taste)
                        {       case 3:
                                        mm=mm->next;
                                        zeit.zliste[m->zidx]=mm->bz;
                                        break;
                                case 1:
                                        m=m->next;
                                        mm=m->daten+zeit.zliste[m->zidx];
                                        break;
                                case 0:
                                        if(veri_tim())
                                                return(FALSE);}}
                                        }
}

BYTE set_clk(HPTM *m)
{

        while(1)
        {       anzeige.analog_uhr.sek_zgr=m->cursor;
                if((taste=(BYTE)get_taste())!=KEINE_TASTE)
                {       switch(taste)
                        {       case 3:
                                case 1:
                                        m=m->next;
                                        break;
                                case 0:
                                        ((BYTE _code(*)(void))m->daten)();
                                        hfunptr=&dumfun;
                                        return(TRUE);
                                        break;}}}
}

BYTE edd(void)
{       ZMTO *m;
        ZTM *mm;

        hfunptr=&set_clk;
        m=(ZMTO*)&dmc0;
        mm=m->daten+zeit.zliste[m->zidx];

        anzeige.edd.skala=(BYTE _code*)&datummenue1;
        show_date();

        while(1)
        {       anzeige.edd.cursor=m->bc;
                *(BYTE _data**)(m->speicher)=*(BYTE _code**)(mm->zeichen);
                if((taste=(BYTE)get_taste())!=KEINE_TASTE)
                {
                        switch(taste)
                        {       case 3:
                                        mm=mm->next;
                                        zeit.zliste[m->zidx]=mm->bz;
                                        break;
                                case 1:
                                        m=m->next;
                                        mm=m->daten+zeit.zliste[m->zidx];
                                        break;
                                case 0:
                                        if(veri_date())
                                                return(FALSE);}}}
}

void init_clock(void)
{       BYTE batt_sts;

        W_REG_F=0x07;
        W_REG_E=0;

        zeit.uhrzeit.einer_sekunde=0;
        zeit.uhrzeit.zehner_sekunde=0;
        zeit.uhrzeit.einer_minute=0;
        zeit.uhrzeit.zehner_minute=0;
        zeit.uhrzeit.einer_stunde=5;
        zeit.uhrzeit.zehner_stunde=1;

        set_rtc_zeit();

        zeit.datum.einer_tag=6;
        zeit.datum.zehner_tag=0;
        zeit.datum.einer_monat=4;
        zeit.datum.zehner_monat=0;
        zeit.datum.einer_jahr=8;
        zeit.datum.zehner_jahr=0;
        set_rtc_datum();


        W_REG_F=0x4;
}

BYTE test_batt(void)
{
        P3.5=1;                         /*batterie von VCC abtrennen und..*/
        if(P3.3)                        /*..spannung messen*/
        {       anzeige.analog_uhr.tablaenge=1;
                anzeige.analog_uhr.skala=(BYTE _code*)&battwarnung;
                while((taste=(BYTE)get_taste())==KEINE_TASTE);
                P3.5=0;
                return(BATT_NOK);}
        else
        {       P3.5=0;
                taste=KEINE_TASTE;
                return(BATT_OK);}


}

BYTE veri_date(void)
{       int Year, Month, Day;

        Year=2000+zeit.datum.zehner_jahr*10+zeit.datum.einer_jahr;
        Month=zeit.datum.zehner_monat*10+zeit.datum.einer_monat;
        Day=zeit.datum.zehner_tag*10+zeit.datum.einer_tag;

        return(vdate(Year, Month, Day)?TRUE:FALSE);
}



/**************************************
 * Is Date a valid Gregorian date format?
 */
int vdate(int Year, int Month, int Day)
   {

   if ((Month < 1) || (Day < 1))
      return 0;
   if ((Month > 12) || (Day > 31))
      return 0;

   if (Month != 2)
   {  if (Day > Days[Month])
         return 0;
      else return 1;}
   else
   {    if (leapyear(Year))
        {       if (Day > 29)
                        return 0;
                else return 1;}
        else
        {       if (Day > 28)
                        return 0;
                else return 1;}}
   }

BYTE veri_tim(void)
{
        return((zeit.uhrzeit.zehner_stunde*10+zeit.uhrzeit.einer_stunde)>23?FALSE:
               (zeit.uhrzeit.zehner_minute*10+zeit.uhrzeit.einer_minute)>59?FALSE:
               (zeit.uhrzeit.zehner_sekunde*10+zeit.uhrzeit.einer_sekunde)>59?FALSE:TRUE);
}
