#define KEINE_TASTE     0xff

/*adresse der dac*/
#define DAC1 *(BYTE _xdata*)0x80e0
#define DAC0 *(BYTE _xdata*)0x80c0

#define RTC_BASIS       0x8000
/*register der rtc*/
#define R_SEC_1         (*(BYTE _xdata *)(RTC_BASIS+0))&0x0f
#define R_SEC_10        (*(BYTE _xdata *)(RTC_BASIS+1))&0x07
#define R_MIN_1         (*(BYTE _xdata *)(RTC_BASIS+2))&0x0f
#define R_MIN_10        (*(BYTE _xdata *)(RTC_BASIS+3))&0x07
#define R_STD_1         (*(BYTE _xdata *)(RTC_BASIS+4))&0x0f
#define R_STD_10        (*(BYTE _xdata *)(RTC_BASIS+5))&0x03
#define R_TAG_1         (*(BYTE _xdata *)(RTC_BASIS+6))&0x0f
#define R_TAG_10        (*(BYTE _xdata *)(RTC_BASIS+7))&0x03
#define R_MON_1         (*(BYTE _xdata *)(RTC_BASIS+8))&0x0f
#define R_MON_10        (*(BYTE _xdata *)(RTC_BASIS+9))&0x01
#define R_JAR_1         (*(BYTE _xdata *)(RTC_BASIS+10))&0x0f
#define R_JAR_10        (*(BYTE _xdata *)(RTC_BASIS+11))&0x0f
#define R_WOCHE         (*(BYTE _xdata *)(RTC_BASIS+12))&0x07
#define R_REG_D         (*(BYTE _xdata *)(RTC_BASIS+13))&0x0f
#define R_REG_E         (*(BYTE _xdata *)(RTC_BASIS+14))&0x0f
#define R_REG_F         (*(BYTE _xdata *)(RTC_BASIS+15))&0x0f

#define W_SEC_1         (*(BYTE _xdata*)(RTC_BASIS+0))
#define W_SEC_10        (*(BYTE _xdata*)(RTC_BASIS+1))
#define W_MIN_1         (*(BYTE _xdata*)(RTC_BASIS+2))
#define W_MIN_10        (*(BYTE _xdata*)(RTC_BASIS+3))
#define W_STD_1         (*(BYTE _xdata*)(RTC_BASIS+4))
#define W_STD_10        (*(BYTE _xdata*)(RTC_BASIS+5))
#define W_TAG_1         (*(BYTE _xdata*)(RTC_BASIS+6))
#define W_TAG_10        (*(BYTE _xdata*)(RTC_BASIS+7))
#define W_MON_1         (*(BYTE _xdata*)(RTC_BASIS+8))
#define W_MON_10        (*(BYTE _xdata*)(RTC_BASIS+9))
#define W_JAR_1         (*(BYTE _xdata*)(RTC_BASIS+10))
#define W_JAR_10        (*(BYTE _xdata*)(RTC_BASIS+11))
#define W_WOCHE         (*(BYTE _xdata*)(RTC_BASIS+12))
#define W_REG_D         (*(BYTE _xdata*)(RTC_BASIS+13))
#define W_REG_E         (*(BYTE _xdata*)(RTC_BASIS+14))
#define W_REG_F         (*(BYTE _xdata*)(RTC_BASIS+15))
#define RTC_HOLD_ON     W_REG_D=(R_REG_D)|0x01;
#define RTC_HOLD_OFF    W_REG_D=(R_REG_D)&0x0e;

/****************** uhrmens *******************************/

/*zeit und datum edit-struktur*/
typedef struct mt{ struct mt *next;
                   BYTE bz;
                   BYTE *zeichen;
                   }ZTM;

/*zeit und datum edit-men*/
typedef struct mto{ struct mto *next;
                    ZTM *daten;
                    BYTE *bc;
                    BYTE zidx;
                    BYTE *speicher;}ZMTO;

/*hauptmen bzw auswahlmen fr die zifferbltter*/
typedef struct m{struct m *prev;
                 struct m *next;
                 BYTE *cursor;
                 BYTE **daten;
                 BYTE (*menufun[4])();
                 }HPTM;

/****************** verweise auf die anzeigedaten *************/
typedef struct{ BYTE  tablaenge;
                BYTE _code *skala;
                BYTE _code *sek_zgr;
                BYTE _code *min_zgr;
                BYTE _code *std_zgr;
                BYTE _code **einer_sek;
                BYTE _code **zehner_sek;
                BYTE _code **einer_min;
                BYTE _code **zehner_min;
                BYTE _code **einer_std;
                BYTE _code **zehner_std;
                BYTE _code **einer_jahr;
                BYTE _code **zehner_jahr;
                BYTE _code **einer_monat;
                BYTE _code **zehner_monat;
                BYTE _code **zehner_tag;
                BYTE _code **einer_tag;
                }ZIFFERBLATT;

typedef struct{ BYTE tablaenge;
                BYTE _code *skala;
                BYTE _code *sekunden_idx;
                BYTE _code **einer_min;
                BYTE _code **zehner_min;
                BYTE _code **einer_std;
                BYTE _code **zehner_std;
                }DIGITALUHR;

typedef struct{ BYTE  tablaenge;
                BYTE _code *skala;
                BYTE _code *sek_zgr;
                BYTE _code *min_zgr;
                BYTE _code *std_zgr;
                }BHF_UHR;


typedef struct{ BYTE tablaenge;
                BYTE _code *skala;
                BYTE _code *cursor;
                BYTE _code **edit_einer_sek;
                BYTE _code **edit_zehner_sek;
                BYTE _code **edit_einer_min;
                BYTE _code **edit_zehner_min;
                BYTE _code **edit_einer_std;
                BYTE _code **edit_zehner_std;
                }EDIT_ZEIT;



typedef struct{ BYTE tablaenge;
                BYTE _code *skala;
                BYTE _code *cursor;
                BYTE _code **edit_einer_tag;
                BYTE _code **edit_zehner_tag;
                BYTE _code **edit_einer_mon;
                BYTE _code **edit_zehner_mon;
                BYTE _code **edit_einer_jahr;
                BYTE _code **edit_zehner_jahr;
                }EDIT_DATUM;


typedef union{ZIFFERBLATT analog_uhr;
              DIGITALUHR digital_uhr;
              EDIT_ZEIT edz;
              EDIT_DATUM edd;
              BHF_UHR bhf_uhr;}MENU;


/****************** die daten aus dem uhr-chip *************/
typedef struct{ BYTE einer_sekunde,
                     zehner_sekunde,
                     einer_minute,
                     zehner_minute,
                     einer_stunde,
                     zehner_stunde;}ZEIT;

typedef struct{ BYTE einer_tag,
                     zehner_tag,
                     einer_monat,
                     zehner_monat,
                     einer_jahr,
                     zehner_jahr;}DATUM;

typedef union{ ZEIT uhrzeit;
               DATUM datum;
               BYTE zliste[6];}TAG;

/*mu sein, fehlt in der definitionsdatei des 8052*/
/*(vom hersteller vergessen worden?)*/
extern _rdata char P1;

/*************** daten sind auf assemblerebene vorhanden *************/

/*die anzeigedaten der analoguhr*/
extern _code BYTE scaledata;
extern _code BYTE hrptrdata[][9];
extern _code BYTE minptrdata[][9];
extern _code BYTE secptrdata[][5];
extern _code BYTE *numsecones[], *numsectens[];
extern _code BYTE *numminones[], *nummintens[];
extern _code BYTE *numhrones[], *numhrtens[];
extern _code BYTE *numdtsones[], *numdtstens[];
extern _code BYTE *numdmoones[], *numdmotens[];
extern _code BYTE *numdtgones[], *numdtgtens[];

/*die anzeigedaten der digitaluhr*/
extern BYTE _code *ndigsecone[];
extern BYTE _code *ndigsecten[];
extern BYTE _code *ndigminone[];
extern BYTE _code ndigskala;
extern BYTE _code *ndigminten[];
extern BYTE _code ndigdeltasek[][9];

/*die anzeigedaten der bahnhofsuhr*/
extern BYTE _code bhfskala;
extern BYTE _code bhfsek[][9];
extern BYTE _code bhfmin[][13];
extern BYTE _code bhfstd[][13];


/*scopedat*/
extern BYTE cursor[][11];

/*die mentexte*/
extern BYTE _code menu;
extern BYTE _code uebertxt;
extern BYTE _code einstellungtxt;
extern BYTE _code zeitmenue3;
extern BYTE _code zeitmenue4;
extern BYTE _code datummenue;
extern BYTE _code datummenue1;
extern BYTE _code battwarnung;

/*der edit-cursor*/
extern BYTE _code blockcursor[][11];

/*daten, die auf assembler-ebene definiert sind und die von c aus ber*/
/*zeiger aus den mens heraus erreicht werden sollen, mssen durch inline-code*/
/*explizit als externe daten erklrt werden. merkwrdig*/ 

#asm
        extrn .menu, .uebertxt, .einstellungtxt
        extrn .zeitmenue3, .zeitmenue4;
        extrn .blockcursor
        extrn .eNumSekOnes,.eNumSekTens,.eNumMinOnes,.eNumMinTens,.eNumStdOnes
        extrn .eNumStdTens
        extrn .datummenue

#endasm

/*die ziffern der editmens: zeit und datum*/
extern BYTE _code eNumSekOnes[][2];
extern BYTE _code eNumSekTens[][2];
extern BYTE _code eNumMinOnes[][2];
extern BYTE _code eNumMinTens[][2];
extern BYTE _code eNumStdOnes[][2];
extern BYTE _code eNumStdTens[][2];

/*********** funktionen ************/
/*scopertc*/
void get_rtc_zeit(void);
void get_rtc_datum(void);
BYTE set_rtc_zeit(void);
BYTE set_rtc_datum(void);
BYTE rtc_busy(void);
void show_alg_clk(void);
void show_dig_clk(void);
void show_bhf_clk(void);
BYTE dumfun(void);
BYTE menuende(void *x);
BYTE edz(void);
BYTE edd(void);
BYTE set_clk(HPTM *m);
void init_clock(void);
BYTE test_batt(void);
BYTE veri_date(void);
BYTE veri_tim(void);

/*scopeasm*/
BYTE get_taste(void);

