#include "8052def.c"
#include "defs.h"
#include "scopeclk.h"

extern TAG zeit;
extern MENU anzeige;


WORD zwary[24]={0,60,120,180,240,300,360,420,480,540,600,660,
                0,60,120,180,240,300,360,420,480,540,600,660};

void get_rtc_zeit(void)
{
        ET0=0;
        if(!rtc_busy())
        {       zeit.uhrzeit.einer_sekunde=(R_SEC_1);
                zeit.uhrzeit.zehner_sekunde=(R_SEC_10);
                zeit.uhrzeit.einer_minute=(R_MIN_1);
                zeit.uhrzeit.zehner_minute=(R_MIN_10);
                zeit.uhrzeit.einer_stunde=(R_STD_1);
                zeit.uhrzeit.zehner_stunde=((R_STD_10));
                }
        ET0=1;
}

void get_rtc_datum(void)
{
        ET0=0;
        if(!rtc_busy())
        {       zeit.datum.einer_tag=(R_TAG_1);
                zeit.datum.zehner_tag=(R_TAG_10);
                zeit.datum.einer_monat=(R_MON_1);
                zeit.datum.zehner_monat=(R_MON_10);
                zeit.datum.einer_jahr=(R_JAR_1);
                zeit.datum.zehner_jahr=(R_JAR_10);
                }
        ET0=1;
}

BYTE set_rtc_zeit(void)
{
        ET0=0;
        if(!rtc_busy())
        {       RTC_HOLD_ON;
                W_STD_10=(zeit.uhrzeit.zehner_stunde)&0x03;
                W_SEC_10=(zeit.uhrzeit.zehner_sekunde)&0x0f;
                W_SEC_1=(zeit.uhrzeit.einer_sekunde)&0x0f;
                W_MIN_10=(zeit.uhrzeit.zehner_minute)&0x0f;
                W_MIN_1=(zeit.uhrzeit.einer_minute)&0x0f;
                W_STD_1=(zeit.uhrzeit.einer_stunde)&0x0f;
                RTC_HOLD_OFF;
                ET0=1;
                return(TRUE);}
        RTC_HOLD_OFF;
        ET0=1;
        return(FALSE);
}

BYTE set_rtc_datum(void)
{
        ET0=0;
        if(!rtc_busy())
        {       RTC_HOLD_ON;
                W_TAG_10=(zeit.datum.zehner_tag)&0x0f;
                W_TAG_1=(zeit.datum.einer_tag)&0x0f;
                W_MON_10=(zeit.datum.zehner_monat)&0x0f;
                W_MON_1=(zeit.datum.einer_monat)&0x0f;
                W_JAR_10=(zeit.datum.zehner_jahr)&0x0f;
                W_JAR_1=(zeit.datum.einer_jahr)&0x0f;
                RTC_HOLD_OFF;
                ET0=1;
                return(TRUE);}
        ET0=1;
        return(FALSE);
}

BYTE rtc_busy(void)
{       return((((R_REG_D)&0x02)==0x02)?FALSE:TRUE);}


void show_alg_clk(void)
{       WORD zw;

        EA=0;
        P1|=0xfc;               /*tastatur-led setzen*/
        P1.3=0;
        EA=1;
        anzeige.analog_uhr.tablaenge=16;
        anzeige.analog_uhr.skala=(BYTE _code*)&scaledata;

        get_rtc_zeit();

        anzeige.analog_uhr.einer_sek=numsecones[zeit.uhrzeit.einer_sekunde];
        anzeige.analog_uhr.zehner_sek=numsectens[zeit.uhrzeit.zehner_sekunde];
        anzeige.analog_uhr.sek_zgr=secptrdata[(WORD)(zeit.uhrzeit.zehner_sekunde*10+zeit.uhrzeit.einer_sekunde)];

        anzeige.analog_uhr.einer_min=numminones[zeit.uhrzeit.einer_minute];
        anzeige.analog_uhr.zehner_min=nummintens[zeit.uhrzeit.zehner_minute];
        anzeige.analog_uhr.min_zgr=minptrdata[(WORD)(zeit.uhrzeit.zehner_minute*10+zeit.uhrzeit.einer_minute)];

        anzeige.analog_uhr.einer_std=numhrones[zeit.uhrzeit.einer_stunde];
        anzeige.analog_uhr.zehner_std=numhrtens[(zeit.uhrzeit.zehner_stunde)];
        zw=zwary[zeit.uhrzeit.zehner_stunde*10+zeit.uhrzeit.einer_stunde];
        zw=(zw+zeit.uhrzeit.zehner_minute*10+zeit.uhrzeit.einer_minute)/12;
        anzeige.analog_uhr.std_zgr=hrptrdata[(WORD)zw];

        get_rtc_datum();
        anzeige.analog_uhr.zehner_jahr=numdtstens[zeit.datum.zehner_jahr];
        anzeige.analog_uhr.einer_jahr=numdtsones[zeit.datum.einer_jahr];
        anzeige.analog_uhr.einer_monat=numdmoones[zeit.datum.einer_monat];
        anzeige.analog_uhr.zehner_monat=numdmotens[zeit.datum.zehner_monat];
        anzeige.analog_uhr.einer_tag=numdtgones[zeit.datum.einer_tag];
        anzeige.analog_uhr.zehner_tag=numdtgtens[zeit.datum.zehner_tag];
}

void show_dig_clk(void)
{

        EA=0;                   /*tastatur-led setzen*/
        P1|=0xfc;
        P1.5=0;
        EA=1;
        anzeige.digital_uhr.tablaenge=6;
        get_rtc_zeit();

        anzeige.digital_uhr.skala=(BYTE _code*)&ndigskala;
        anzeige.digital_uhr.sekunden_idx=ndigdeltasek[(WORD)(zeit.uhrzeit.zehner_sekunde*10+zeit.uhrzeit.einer_sekunde)];
        anzeige.digital_uhr.einer_min=ndigsecone[zeit.uhrzeit.einer_minute];
        anzeige.digital_uhr.zehner_min=ndigsecten[zeit.uhrzeit.zehner_minute];
        anzeige.digital_uhr.einer_std=ndigminone[zeit.uhrzeit.einer_stunde];
        anzeige.digital_uhr.zehner_std=ndigminten[zeit.uhrzeit.zehner_stunde];
}

void show_bhf_clk(void)
{       WORD zw;

        EA=0;
        P1|=0xfc;               /*tastatur-led setzen*/
        P1.7=0;
        EA=1;
        get_rtc_zeit();

        anzeige.bhf_uhr.tablaenge=4;
        anzeige.bhf_uhr.skala=(BYTE _code*)&bhfskala;
        anzeige.bhf_uhr.sek_zgr=&bhfsek[(zeit.uhrzeit.zehner_sekunde*10+zeit.uhrzeit.einer_sekunde)];
        anzeige.bhf_uhr.min_zgr=&bhfmin[(zeit.uhrzeit.zehner_minute*10+zeit.uhrzeit.einer_minute)];
        zw=zwary[zeit.uhrzeit.zehner_stunde*10+zeit.uhrzeit.einer_stunde];
        zw=(zw+zeit.uhrzeit.zehner_minute*10+zeit.uhrzeit.einer_minute)/12;
        anzeige.bhf_uhr.std_zgr=&bhfstd[(WORD)zw];


}
